=== removed file 'drizzled/function/str/user.cc'
--- drizzled/function/str/user.cc	2010-02-10 23:50:24 +0000
+++ drizzled/function/str/user.cc	1970-01-01 00:00:00 +0000
@@ -1,74 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-
-#include <drizzled/function/str/user.h>
-#include <drizzled/session.h>
-
-namespace drizzled
-{
-
-/**
-  @todo
-  make USER() replicate properly (currently it is replicated to "")
-*/
-bool Item_func_user::init(const char *user, const char *host)
-{
-  assert(fixed == 1);
-
-  // For system threads (e.g. replication SQL thread) user may be empty
-  if (user)
-  {
-    const CHARSET_INFO * const cs= str_value.charset();
-    uint32_t res_length= (strlen(user)+strlen(host)+2) * cs->mbmaxlen;
-
-    if (str_value.alloc(res_length))
-    {
-      null_value=1;
-      return true;
-    }
-
-    res_length=cs->cset->snprintf(cs, (char*)str_value.ptr(), res_length,
-                                  "%s@%s", user, host);
-    str_value.length(res_length);
-    str_value.mark_as_const();
-  }
-  return false;
-}
-
-
-bool Item_func_user::fix_fields(Session *session, Item **ref)
-{
-  return (Item_str_func::fix_fields(session, ref) ||
-          init(session->getSecurityContext().getUser().c_str(),
-               session->getSecurityContext().getIp().c_str()));
-}
-
-
-bool Item_func_current_user::fix_fields(Session *session, Item **ref)
-{
-  if (Item_str_func::fix_fields(session, ref))
-    return true;
-
-  const SecurityContext *ctx= &session->getSecurityContext();
-  return init(ctx->getUser().c_str(), ctx->getIp().c_str());
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/user.h'
--- drizzled/function/str/user.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/user.h	1970-01-01 00:00:00 +0000
@@ -1,73 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_USER_H
-#define DRIZZLED_FUNCTION_STR_USER_H
-
-#include <drizzled/function/str/strfunc.h>
-#include "drizzled/global_charset_info.h"
-
-namespace drizzled
-{
-
-class Item_func_user :public Item_str_func
-{
-protected:
-  bool init (const char *user, const char *host);
-
-public:
-  Item_func_user()
-  {
-    str_value.set("", 0, system_charset_info);
-  }
-  String *val_str(String *)
-  {
-    assert(fixed == 1);
-    return (null_value ? 0 : &str_value);
-  }
-  bool fix_fields(Session *session, Item **ref);
-  void fix_length_and_dec()
-  {
-    max_length= (USERNAME_CHAR_LENGTH + HOSTNAME_LENGTH + 1) *
-                system_charset_info->mbmaxlen;
-  }
-  const char *func_name() const { return "user"; }
-  const char *fully_qualified_func_name() const { return "user()"; }
-  int save_in_field(Field *field,
-                    bool )
-  {
-    return save_str_value_in_field(field, &str_value);
-  }
-};
-
-class Item_func_current_user :public Item_func_user
-{
-  Name_resolution_context *context;
-
-public:
-  Item_func_current_user(Name_resolution_context *context_arg)
-    : context(context_arg) {}
-  bool fix_fields(Session *session, Item **ref);
-  const char *func_name() const { return "current_user"; }
-  const char *fully_qualified_func_name() const { return "current_user()"; }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_USER_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-03-16 23:26:33 +0000
+++ drizzled/include.am	2010-03-18 11:20:28 +0000
@@ -157,7 +157,6 @@
 			      drizzled/function/str/str_conv.h \
 			      drizzled/function/str/strfunc.h \
 			      drizzled/function/str/trim.h \
-			      drizzled/function/str/user.h \
 			      drizzled/function/time/curdate.h \
 			      drizzled/function/time/date.h \
 			      drizzled/function/time/date_add_interval.h \
@@ -556,7 +555,6 @@
 			   drizzled/function/str/str_conv.cc \
 			   drizzled/function/str/strfunc.cc \
 			   drizzled/function/str/trim.cc \
-			   drizzled/function/str/user.cc \
 			   drizzled/function/time/curdate.cc \
 			   drizzled/function/time/date.cc \
 			   drizzled/function/time/date_add_interval.cc \

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2010-02-23 21:26:50 +0000
+++ drizzled/parser.h	2010-03-18 11:20:28 +0000
@@ -28,8 +28,6 @@
 #include <drizzled/function/str/right.h>
 #include <drizzled/function/str/set_collation.h>
 #include <drizzled/function/str/trim.h>
-#include <drizzled/function/str/user.h>
-
 #include <drizzled/function/time/curdate.h>
 #include <drizzled/function/time/date_add_interval.h>
 #include <drizzled/function/time/dayofmonth.h>

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-03-16 23:42:10 +0000
+++ drizzled/sql_yacc.yy	2010-03-18 11:20:28 +0000
@@ -2979,7 +2979,11 @@
           { $$= new (YYSession->mem_root) Item_func_char(*$3); }
         | CURRENT_USER optional_braces
           {
-            $$= new (YYSession->mem_root) Item_func_current_user(Lex->current_context());
+            std::string user_str("user");
+            if (! ($$= reserved_keyword_function(user_str, NULL)))
+            {
+              DRIZZLE_YYABORT;
+            }
           }
         | DATE_SYM '(' expr ')'
           { $$= new (YYSession->mem_root) Item_date_typecast($3); }
@@ -3036,7 +3040,11 @@
           { $$= new (YYSession->mem_root) Item_func_trim($5,$3); }
         | USER '(' ')'
           {
-            $$= new (YYSession->mem_root) Item_func_user();
+            std::string user_str("user");
+            if (! ($$= reserved_keyword_function(user_str, NULL)))
+            {
+              DRIZZLE_YYABORT;
+            }
           }
         | YEAR_SYM '(' expr ')'
           { $$= new (YYSession->mem_root) Item_func_year($3); }

=== added directory 'plugin/user_function'
=== added file 'plugin/user_function/plugin.ini'
--- plugin/user_function/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/user_function/plugin.ini	2010-03-18 11:20:28 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=USER() Function
+description=Gets current user
+load_by_default=yes

=== added file 'plugin/user_function/user_function.cc'
--- plugin/user_function/user_function.cc	1970-01-01 00:00:00 +0000
+++ plugin/user_function/user_function.cc	2010-03-18 11:20:28 +0000
@@ -0,0 +1,127 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/plugin/function.h>
+#include <drizzled/session.h>
+
+using namespace std;
+using namespace drizzled;
+
+#include <drizzled/function/str/strfunc.h>
+
+class UserFunction :public Item_str_func
+{
+protected:
+  bool init (const char *user, const char *host);
+
+public:
+  UserFunction()
+  {
+    str_value.set("", 0, system_charset_info);
+  }
+  String *val_str(String *)
+  {
+    assert(fixed == 1);
+    return (null_value ? 0 : &str_value);
+  }
+  bool fix_fields(Session *session, Item **ref);
+  void fix_length_and_dec()
+  {
+    max_length= (USERNAME_CHAR_LENGTH + HOSTNAME_LENGTH + 1) *
+                system_charset_info->mbmaxlen;
+  }
+  const char *func_name() const { return "user"; }
+  const char *fully_qualified_func_name() const { return "user()"; }
+  int save_in_field(Field *field,
+                    bool )
+  {
+    return save_str_value_in_field(field, &str_value);
+  }
+};
+
+/**
+  @todo
+  make USER() replicate properly (currently it is replicated to "")
+*/
+bool UserFunction::init(const char *user, const char *host)
+{
+  assert(fixed == 1);
+
+  // For system threads (e.g. replication SQL thread) user may be empty
+  if (user)
+  {
+    const CHARSET_INFO * const cs= str_value.charset();
+    uint32_t res_length= (strlen(user)+strlen(host)+2) * cs->mbmaxlen;
+
+    if (str_value.alloc(res_length))
+    {
+      null_value=1;
+      return true;
+    }
+
+    res_length=cs->cset->snprintf(cs, (char*)str_value.ptr(), res_length,
+                                  "%s@%s", user, host);
+    str_value.length(res_length);
+    str_value.mark_as_const();
+  }
+  return false;
+}
+
+
+bool UserFunction::fix_fields(Session *session, Item **ref)
+{
+  return (Item_str_func::fix_fields(session, ref) ||
+          init(session->getSecurityContext().getUser().c_str(),
+               session->getSecurityContext().getIp().c_str()));
+}
+
+
+plugin::Create_function<UserFunction> *user_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  user_function= new plugin::Create_function<UserFunction>("user");
+  registry.add(user_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(user_function);
+   delete user_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "user_function",
+  "1.0",
+  "Stewart Smith",
+  "USER() and CURRENT_USER()",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

